#line 1 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 4 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
const VRefSet = 5000;


unsigned int ADCIn = 0, Vdd = 0, VRefIn = 0;


char txt[16];
void PrintHandler(char c)
{
 UART1_Write(c);
}

void UART1_jump_a_line()
{
 UART1_Write(10);
 UART1_Write(13);
}


const unsigned int USBRamStart=0x500;
const unsigned short USBInDataLength=64, USBOutDataLength=64;


char buffer[64] absolute 0x500 ;


bit USBHasEnteredSuspendMode;
unsigned short USBCount;
unsigned short USBInData[USBInDataLength] absolute USBRamStart+USBInDataLength;
unsigned short USBOutData[USBOutDataLength] absolute USBRamStart;






void main();

void ADC_Init() {

 ADCON0.ADON = 1;


 ADCON1.VCFG0 = 0;


 ADCON1.VCFG1 = 0;
#line 65 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
 ADCON2.ADCS2 = 1;
 ADCON2.ADCS1 = 1;
 ADCON2.ADCS0 = 0;


 ADCON2.ACQT2 = 0;
 ADCON2.ACQT1 = 0;
 ADCON2.ACQT0 = 1;


 ADCON2.ADFM = 1;
}

unsigned int ADC_Get_Sample(unsigned short Channel)
{


 unsigned int Result = 0;


 ADCON0 = (Channel << 2) + 1;


 ADCON0.GO = 1;
 while (ADCON0.GO);


  ((char *)&Result)[0]  = ADRESL;
  ((char *)&Result)[1]  = ADRESH;




 return Result;
}


void USBEnterSuspendMode() {
 USBHasEnteredSuspendMode = 1;
}


void USBExitSuspendMode() {
 USBHasEnteredSuspendMode = 0;
}

void interrupt() {

 USB_Interrupt_Proc();
}

void USBDev_CDCParamsChanged(){

}

uint8_t dataReceived = 0;
uint16_t dataReceivedSize;

void interrupt_low() {
}
#line 143 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
void main()
{
#line 155 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
 UART1_Init(115200);

 USBHasEnteredSuspendMode = 0;
 for (USBCount = 0; USBCount < 64; USBCount++) {
 USBInData[USBCount] = USBOutData[USBCount] = 255;
 }


 TRISA = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 TRISE = 0;
 TRISB.B4 = 1;
 RBPU_bit = 0;


 TRISA.TRISA0 = 1;
 ADCON1 = 0b001110;
 ADC_Init();


 HID_Enable(&USBInData, &USBOutData);


 VRefIn = 4095;


 Vdd = (unsigned long int) 4095 * VRefSet / VRefIn;


 while(1)
 {

 if(UCON.SUSPND) {
 if(!USBHasEnteredSuspendMode) {

 USBEnterSuspendMode();
 } else {

 PORTC = 85;
 Delay_ms(25);
 PORTC = 170;
 Delay_ms(25);


 continue;
 }
 } else {
 if (USBHasEnteredSuspendMode) {
 USBExitSuspendMode();
 }
 }
#line 221 "F:/Z/Dropbox/# BootProg 2.3 #/USB-HID ADC PIC 18F4550 - 20MHz - MikroC/Project.c"
 PORTB.RB5 = 1;

 ADCIn = ADC_Get_Sample(0);








 PORTD = ADCIn >> 2;

 IntToStr(ADCIn, txt);
 UART1_Write_Text(txt);
 UART1_jump_a_line();
 PORTB.RB5 = 0;

 if(HID_Read())
 {
 USBOutData[0] = 12;
 USBOutData[1] =  ((char *)&ADCIn)[1] ;
 USBOutData[2] =  ((char *)&ADCIn)[0] ;
 USBOutData[3] =  ((char *)&Vdd)[1] ;
 USBOutData[4] =  ((char *)&Vdd)[0] ;
 USBOutData[5] =  ((char *)&VRefIn)[1] ;
 USBOutData[6] =  ((char *)&VRefIn)[0] ;
 HID_Write(&USBOutData, USBOutDataLength);
 }
 }


 HID_Disable();
}
