
_PrintHandler:

;Project.c,11 :: 		void PrintHandler(char c)
;Project.c,13 :: 		UART1_Write(c);
	MOVF        FARG_PrintHandler_c+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;Project.c,14 :: 		}
L_end_PrintHandler:
	RETURN      0
; end of _PrintHandler

_UART1_jump_a_line:

;Project.c,16 :: 		void UART1_jump_a_line()
;Project.c,18 :: 		UART1_Write(10);
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;Project.c,19 :: 		UART1_Write(13);
	MOVLW       13
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;Project.c,20 :: 		}
L_end_UART1_jump_a_line:
	RETURN      0
; end of _UART1_jump_a_line

_ADC_Init:

;Project.c,42 :: 		void ADC_Init() {
;Project.c,44 :: 		ADCON0.ADON = 1;
	BSF         ADCON0+0, 0 
;Project.c,47 :: 		ADCON1.VCFG0 = 0;
	BCF         ADCON1+0, 4 
;Project.c,50 :: 		ADCON1.VCFG1 = 0;
	BCF         ADCON1+0, 5 
;Project.c,65 :: 		ADCON2.ADCS2 = 1;
	BSF         ADCON2+0, 2 
;Project.c,66 :: 		ADCON2.ADCS1 = 1;
	BSF         ADCON2+0, 1 
;Project.c,67 :: 		ADCON2.ADCS0 = 0;
	BCF         ADCON2+0, 0 
;Project.c,70 :: 		ADCON2.ACQT2 = 0;
	BCF         ADCON2+0, 5 
;Project.c,71 :: 		ADCON2.ACQT1 = 0;
	BCF         ADCON2+0, 4 
;Project.c,72 :: 		ADCON2.ACQT0 = 1;
	BSF         ADCON2+0, 3 
;Project.c,75 :: 		ADCON2.ADFM = 1;
	BSF         ADCON2+0, 7 
;Project.c,76 :: 		}
L_end_ADC_Init:
	RETURN      0
; end of _ADC_Init

_ADC_Get_Sample:

;Project.c,78 :: 		unsigned int ADC_Get_Sample(unsigned short Channel)
;Project.c,82 :: 		unsigned int Result = 0;
	CLRF        ADC_Get_Sample_Result_L0+0 
	CLRF        ADC_Get_Sample_Result_L0+1 
;Project.c,85 :: 		ADCON0 = (Channel << 2) + 1;
	MOVF        FARG_ADC_Get_Sample_Channel+0, 0 
	MOVWF       R0 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R0, 1 
	BCF         R0, 0 
	MOVF        R0, 0 
	ADDLW       1
	MOVWF       ADCON0+0 
;Project.c,88 :: 		ADCON0.GO = 1;
	BSF         ADCON0+0, 1 
;Project.c,89 :: 		while (ADCON0.GO);
L_ADC_Get_Sample0:
	BTFSS       ADCON0+0, 1 
	GOTO        L_ADC_Get_Sample1
	GOTO        L_ADC_Get_Sample0
L_ADC_Get_Sample1:
;Project.c,92 :: 		Lo(Result) = ADRESL;
	MOVF        ADRESL+0, 0 
	MOVWF       ADC_Get_Sample_Result_L0+0 
;Project.c,93 :: 		Hi(Result) = ADRESH;
	MOVF        ADRESH+0, 0 
	MOVWF       ADC_Get_Sample_Result_L0+1 
;Project.c,98 :: 		return Result;
	MOVF        ADC_Get_Sample_Result_L0+0, 0 
	MOVWF       R0 
	MOVF        ADC_Get_Sample_Result_L0+1, 0 
	MOVWF       R1 
;Project.c,99 :: 		}
L_end_ADC_Get_Sample:
	RETURN      0
; end of _ADC_Get_Sample

_USBEnterSuspendMode:

;Project.c,102 :: 		void USBEnterSuspendMode() {
;Project.c,103 :: 		USBHasEnteredSuspendMode = 1;
	BSF         _USBHasEnteredSuspendMode+0, BitPos(_USBHasEnteredSuspendMode+0) 
;Project.c,104 :: 		}
L_end_USBEnterSuspendMode:
	RETURN      0
; end of _USBEnterSuspendMode

_USBExitSuspendMode:

;Project.c,107 :: 		void USBExitSuspendMode() {
;Project.c,108 :: 		USBHasEnteredSuspendMode = 0;
	BCF         _USBHasEnteredSuspendMode+0, BitPos(_USBHasEnteredSuspendMode+0) 
;Project.c,109 :: 		}
L_end_USBExitSuspendMode:
	RETURN      0
; end of _USBExitSuspendMode

_interrupt:

;Project.c,111 :: 		void interrupt() {
;Project.c,113 :: 		USB_Interrupt_Proc();
	CALL        _USB_Interrupt_Proc+0, 0
;Project.c,114 :: 		}
L_end_interrupt:
L__interrupt22:
	RETFIE      1
; end of _interrupt

_USBDev_CDCParamsChanged:

;Project.c,116 :: 		void USBDev_CDCParamsChanged(){
;Project.c,118 :: 		}
L_end_USBDev_CDCParamsChanged:
	RETURN      0
; end of _USBDev_CDCParamsChanged

_interrupt_low:
	MOVWF       ___Low_saveWREG+0 
	MOVF        STATUS+0, 0 
	MOVWF       ___Low_saveSTATUS+0 
	MOVF        BSR+0, 0 
	MOVWF       ___Low_saveBSR+0 

;Project.c,123 :: 		void interrupt_low() {
;Project.c,124 :: 		}
L_end_interrupt_low:
L__interrupt_low25:
	MOVF        ___Low_saveBSR+0, 0 
	MOVWF       BSR+0 
	MOVF        ___Low_saveSTATUS+0, 0 
	MOVWF       STATUS+0 
	SWAPF       ___Low_saveWREG+0, 1 
	SWAPF       ___Low_saveWREG+0, 0 
	RETFIE      0
; end of _interrupt_low

_main:

;Project.c,143 :: 		void main()
;Project.c,155 :: 		UART1_Init(115200); //9600);  // Initialize UART module at 9600 bps
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       103
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;Project.c,157 :: 		USBHasEnteredSuspendMode = 0;
	BCF         _USBHasEnteredSuspendMode+0, BitPos(_USBHasEnteredSuspendMode+0) 
;Project.c,158 :: 		for (USBCount = 0; USBCount < 64; USBCount++) {
	CLRF        _USBCount+0 
L_main2:
	MOVLW       64
	SUBWF       _USBCount+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main3
;Project.c,159 :: 		USBInData[USBCount] = USBOutData[USBCount] = 255;
	MOVLW       _USBInData+0
	MOVWF       R2 
	MOVLW       hi_addr(_USBInData+0)
	MOVWF       R3 
	MOVF        _USBCount+0, 0 
	ADDWF       R2, 1 
	BTFSC       STATUS+0, 0 
	INCF        R3, 1 
	MOVLW       _USBOutData+0
	MOVWF       R0 
	MOVLW       hi_addr(_USBOutData+0)
	MOVWF       R1 
	MOVF        _USBCount+0, 0 
	ADDWF       R0, 1 
	BTFSC       STATUS+0, 0 
	INCF        R1, 1 
	MOVFF       R0, FSR1
	MOVFF       R1, FSR1H
	MOVLW       255
	MOVWF       POSTINC1+0 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVFF       R2, FSR1
	MOVFF       R3, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Project.c,158 :: 		for (USBCount = 0; USBCount < 64; USBCount++) {
	INCF        _USBCount+0, 1 
;Project.c,160 :: 		}
	GOTO        L_main2
L_main3:
;Project.c,163 :: 		TRISA = 0;              //Set PORTA as output
	CLRF        TRISA+0 
;Project.c,164 :: 		TRISB = 0;              //Set PORTB as output
	CLRF        TRISB+0 
;Project.c,165 :: 		TRISC = 0;              //Set PORTC as output
	CLRF        TRISC+0 
;Project.c,166 :: 		TRISD = 0;              //Set PORTD as output
	CLRF        TRISD+0 
;Project.c,167 :: 		TRISE = 0;              //Set PORTE as output
	CLRF        TRISE+0 
;Project.c,168 :: 		TRISB.B4 = 1;           //RB4 switch
	BSF         TRISB+0, 4 
;Project.c,169 :: 		RBPU_bit = 0;           //Enable weak pull-up on all ports
	BCF         RBPU_bit+0, BitPos(RBPU_bit+0) 
;Project.c,172 :: 		TRISA.TRISA0 = 1;
	BSF         TRISA+0, 0 
;Project.c,173 :: 		ADCON1 = 0b001110;
	MOVLW       14
	MOVWF       ADCON1+0 
;Project.c,174 :: 		ADC_Init();
	CALL        _ADC_Init+0, 0
;Project.c,177 :: 		HID_Enable(&USBInData, &USBOutData);
	MOVLW       _USBInData+0
	MOVWF       FARG_HID_Enable_readbuff+0 
	MOVLW       hi_addr(_USBInData+0)
	MOVWF       FARG_HID_Enable_readbuff+1 
	MOVLW       _USBOutData+0
	MOVWF       FARG_HID_Enable_writebuff+0 
	MOVLW       hi_addr(_USBOutData+0)
	MOVWF       FARG_HID_Enable_writebuff+1 
	CALL        _HID_Enable+0, 0
;Project.c,180 :: 		VRefIn = 4095;
	MOVLW       255
	MOVWF       _VRefIn+0 
	MOVLW       15
	MOVWF       _VRefIn+1 
;Project.c,183 :: 		Vdd = (unsigned long int) 4095 * VRefSet / VRefIn;
	MOVLW       136
	MOVWF       _Vdd+0 
	MOVLW       19
	MOVWF       _Vdd+1 
;Project.c,186 :: 		while(1)
L_main5:
;Project.c,189 :: 		if(UCON.SUSPND) {
	BTFSS       UCON+0, 1 
	GOTO        L_main7
;Project.c,190 :: 		if(!USBHasEnteredSuspendMode) {
	BTFSC       _USBHasEnteredSuspendMode+0, BitPos(_USBHasEnteredSuspendMode+0) 
	GOTO        L_main8
;Project.c,192 :: 		USBEnterSuspendMode();
	CALL        _USBEnterSuspendMode+0, 0
;Project.c,193 :: 		} else {
	GOTO        L_main9
L_main8:
;Project.c,195 :: 		PORTC = 85;
	MOVLW       85
	MOVWF       PORTC+0 
;Project.c,196 :: 		Delay_ms(25);
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L_main10:
	DECFSZ      R13, 1, 1
	BRA         L_main10
	DECFSZ      R12, 1, 1
	BRA         L_main10
	DECFSZ      R11, 1, 1
	BRA         L_main10
;Project.c,197 :: 		PORTC = 170;
	MOVLW       170
	MOVWF       PORTC+0 
;Project.c,198 :: 		Delay_ms(25);
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L_main11:
	DECFSZ      R13, 1, 1
	BRA         L_main11
	DECFSZ      R12, 1, 1
	BRA         L_main11
	DECFSZ      R11, 1, 1
	BRA         L_main11
;Project.c,201 :: 		continue;
	GOTO        L_main5
;Project.c,202 :: 		}
L_main9:
;Project.c,203 :: 		} else {
	GOTO        L_main12
L_main7:
;Project.c,204 :: 		if (USBHasEnteredSuspendMode) {
	BTFSS       _USBHasEnteredSuspendMode+0, BitPos(_USBHasEnteredSuspendMode+0) 
	GOTO        L_main13
;Project.c,205 :: 		USBExitSuspendMode();
	CALL        _USBExitSuspendMode+0, 0
;Project.c,206 :: 		}
L_main13:
;Project.c,207 :: 		}
L_main12:
;Project.c,221 :: 		PORTB.RB5 = 1;
	BSF         PORTB+0, 5 
;Project.c,223 :: 		ADCIn = ADC_Get_Sample(0);
	CLRF        FARG_ADC_Get_Sample_Channel+0 
	CALL        _ADC_Get_Sample+0, 0
	MOVF        R0, 0 
	MOVWF       _ADCIn+0 
	MOVF        R1, 0 
	MOVWF       _ADCIn+1 
;Project.c,232 :: 		PORTD = ADCIn >> 2;   // PIC 18F4550
	MOVF        R0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       R3 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	MOVF        R2, 0 
	MOVWF       PORTD+0 
;Project.c,234 :: 		IntToStr(ADCIn, txt);
	MOVF        R0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        R1, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _txt+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;Project.c,235 :: 		UART1_Write_Text(txt);  // sends back text
	MOVLW       _txt+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Project.c,236 :: 		UART1_jump_a_line();
	CALL        _UART1_jump_a_line+0, 0
;Project.c,237 :: 		PORTB.RB5 = 0;
	BCF         PORTB+0, 5 
;Project.c,239 :: 		if(HID_Read())
	CALL        _HID_Read+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
;Project.c,241 :: 		USBOutData[0] = 12;        //ADC Resolution
	MOVLW       12
	MOVWF       1280 
;Project.c,242 :: 		USBOutData[1] = Hi(ADCIn);
	MOVF        _ADCIn+1, 0 
	MOVWF       1281 
;Project.c,243 :: 		USBOutData[2] = Lo(ADCIn);
	MOVF        _ADCIn+0, 0 
	MOVWF       1282 
;Project.c,244 :: 		USBOutData[3] = Hi(Vdd);
	MOVF        _Vdd+1, 0 
	MOVWF       1283 
;Project.c,245 :: 		USBOutData[4] = Lo(Vdd);
	MOVF        _Vdd+0, 0 
	MOVWF       1284 
;Project.c,246 :: 		USBOutData[5] = Hi(VRefIn);
	MOVF        _VRefIn+1, 0 
	MOVWF       1285 
;Project.c,247 :: 		USBOutData[6] = Lo(VRefIn);
	MOVF        _VRefIn+0, 0 
	MOVWF       1286 
;Project.c,248 :: 		HID_Write(&USBOutData, USBOutDataLength);
	MOVLW       _USBOutData+0
	MOVWF       FARG_HID_Write_writebuff+0 
	MOVLW       hi_addr(_USBOutData+0)
	MOVWF       FARG_HID_Write_writebuff+1 
	MOVLW       64
	MOVWF       FARG_HID_Write_len+0 
	CALL        _HID_Write+0, 0
;Project.c,249 :: 		}
L_main14:
;Project.c,250 :: 		}
	GOTO        L_main5
;Project.c,254 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
